/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.executable.rumblepad;

import static org.fortiss.af3.expression.utils.ExpressionModelElementFactory.funcCall;

import org.fortiss.af3.component.model.InputPort;
import org.fortiss.af3.expression.model.terms.IExpressionTerm;
import org.fortiss.af3.platform.language.executable.ReceiverExecutableBase;
import org.fortiss.af3.platform.raspberry.model.rumblepad.DPadDown;

/**
 * Executable for {@link DPadDown}.
 * 
 * @author eder
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash:
 */
public class DPadDownExecutable extends ReceiverExecutableBase<DPadDown> {

	/** Constructor. */
	public DPadDownExecutable(DPadDown modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	public IExpressionTerm getInitialization() {
		return funcCall("rp_init");
	}

	/** {@inheritDoc} */
	public IExpressionTerm getNoValGuardAccessor(InputPort logicalSignal) {
		return funcCall("rp_btnDPadDown_is_noval");
	}

	/** {@inheritDoc} */
	public IExpressionTerm getTermination() {
		return funcCall("rp_term");
	}

	/** {@inheritDoc} */
	public IExpressionTerm getValueReadAccessor(InputPort logicalSignal) {
		return funcCall("rp_btnDPadDown_read");
	}
}
