/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2017 fortiss GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.transform.rumblepad;

import org.fortiss.af3.platform.raspberry.generator.executable.rumblepad.L2PositionExecutable;
import org.fortiss.af3.platform.raspberry.model.rumblepad.L2_Position;
import org.fortiss.tooling.kernel.extension.ITransformationProvider;
import org.fortiss.tooling.kernel.extension.data.ITransformationContext;

/**
 * Transformation for {@link L2_Position}.
 * 
 * @author eder
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating RED Hash:
 */
public class L2PositionTransformation implements ITransformationProvider {

	/** {@inheritDoc} */
	@Override
	public Class<?> getTargetClass() {
		return L2PositionExecutable.class;
	}

	/** {@inheritDoc} */
	@Override
	public boolean
			canHandleChainTransformation(Class<?> sourceClass, ITransformationContext context) {
		return L2_Position.class.isAssignableFrom(sourceClass);
	}

	/** {@inheritDoc} */
	@Override
	public boolean canTransform(Object source, ITransformationContext context) {
		return source instanceof L2_Position;
	}

	/** {@inheritDoc} */
	@Override
	public Object transform(Object source, ITransformationContext context) {
		return new L2PositionExecutable((L2_Position)source);
	}

}
